package handler

import (
	"context"
	"net/http"

	pb "git.unistack.org/unistack-org/pkgdash/proto"
	httpsrv "go.unistack.org/micro-server-http/v4"
	"go.unistack.org/micro/v4/logger"
)

func (h *Handler) PackageDelete(ctx context.Context, req *pb.PackageDeleteReq, rsp *pb.PackageDeleteRsp) error {
	logger.Debug(ctx, "Start UpdatePackage")

	if err := req.Validate(); err != nil {
		logger.Error(ctx, "validate error", err)
		httpsrv.SetRspCode(ctx, http.StatusBadRequest)
		return httpsrv.SetError(NewValidationError(err))
	}

	if err := h.store.PackageDelete(ctx, req); err != nil {
		logger.Error(ctx, "package delete error", err)
		httpsrv.SetRspCode(ctx, http.StatusInternalServerError)
		return httpsrv.SetError(NewInternalError(err))
	}

	logger.Debug(ctx, "Success finish UpdatePackage")
	return nil
}
